using Phoenix.Core;
using Phoenix.HabboHotel.GameClients;
using Phoenix.HabboHotel.Items;
using Phoenix.HabboHotel.Misc;
using Phoenix.HabboHotel.Pets;
using Phoenix.HabboHotel.Rooms;
using Phoenix.Messages;
using Phoenix.Storage;
using Phoenix.Util;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
namespace Phoenix.HabboHotel.Catalogs
{
	internal class Class91
	{
		public Dictionary<int, Class92> dictionary_0;
		public List<Class94> list_0;
		private Class95 class95_0;
		private Class96 class96_0;
		private GClass6[] gclass6_0;
		private uint uint_0;
		private readonly object object_0 = new object();
		public Class91()
		{
			this.class95_0 = new Class95();
			this.class96_0 = new Class96();
		}
		public void method_0(Class13 class13_0)
		{
			GClass2.smethod_0("Loading Catalogue..");
			this.dictionary_0 = new Dictionary<int, Class92>();
			this.list_0 = new List<Class94>();
			DataTable dataTable = class13_0.method_3("SELECT * FROM catalog_pages ORDER BY order_num ASC");
			DataTable dataTable2 = class13_0.method_3("SELECT * FROM ecotron_rewards ORDER BY item_id");
			try
			{
				this.uint_0 = (uint)class13_0.method_4("SELECT ID FROM items ORDER BY ID DESC LIMIT 1")[0];
			}
			catch
			{
				this.uint_0 = 0u;
			}
			
			{
				this.uint_0 += 1u;
				Hashtable hashtable = new Hashtable();
				DataTable dataTable3 = class13_0.method_3("SELECT * FROM catalog_items");
				if (dataTable3 != null)
				{
					foreach (DataRow dataRow in dataTable3.Rows)
					{
						if (!(dataRow["item_ids"].ToString() == "") && (int)dataRow["amount"] > 0)
						{
							hashtable.Add((uint)dataRow["id"], new Class93((uint)dataRow["id"], (string)dataRow["catalog_name"], (string)dataRow["item_ids"], (int)dataRow["cost_credits"], (int)dataRow["cost_pixels"], (int)dataRow["cost_snow"], (int)dataRow["amount"], (int)dataRow["page_id"], Class1.smethod_2(dataRow["vip"].ToString())));
						}
					}
				}
				if (dataTable != null)
				{
					foreach (DataRow dataRow2 in dataTable.Rows)
					{
						bool visible = false;
						bool enabled = false;
						if (dataRow2["visible"].ToString() == "1")
						{
							visible = true;
						}
						if (dataRow2["enabled"].ToString() == "1")
						{
							enabled = true;
						}
						this.dictionary_0.Add((int)dataRow2["id"], new Class92((int)dataRow2["id"], (int)dataRow2["parent_id"], (string)dataRow2["caption"], visible, enabled, (uint)dataRow2["min_rank"], Class1.smethod_3(dataRow2["club_only"].ToString()), (int)dataRow2["icon_color"], (int)dataRow2["icon_image"], (string)dataRow2["page_layout"], (string)dataRow2["page_headline"], (string)dataRow2["page_teaser"], (string)dataRow2["page_special"], (string)dataRow2["page_text1"], (string)dataRow2["page_text2"], (string)dataRow2["page_text_details"], (string)dataRow2["page_text_teaser"], (string)dataRow2["page_link_description"], (string)dataRow2["page_link_pagename"], ref hashtable, (uint)dataRow2["room_id"]));
					}
				}
				if (dataTable2 != null)
				{
					foreach (DataRow dataRow3 in dataTable2.Rows)
					{
						this.list_0.Add(new Class94((uint)dataRow3["id"], (uint)dataRow3["display_id"], (uint)dataRow3["item_id"], (uint)dataRow3["reward_level"]));
					}
				}
			}
		}
		internal void method_1()
		{
			GClass2.smethod_0("Loading Catalogue Cache..");
			this.gclass6_0 = new GClass6[8];
			
			{
				for (int i = 1; i < 8; i++)
				{
					this.gclass6_0[i] = this.method_19(i);
				}
				foreach (Class92 current in this.dictionary_0.Values)
				{
					current.method_0();
				}
			}
		}
		public Class93 method_2(uint uint_1)
		{
			foreach (Class92 current in this.dictionary_0.Values)
			{
				foreach (Class93 current2 in current.list_0)
				{
					if (current2.uint_0 == uint_1)
					{
						return current2;
					}
				}
			}
			return null;
		}
		public bool method_3(uint uint_1)
		{
			DataRow result = null;
			using (Class13 @class = Class1.smethod_12().method_0())
			{
				result = @class.method_4("SELECT id FROM catalog_items WHERE item_ids = '" + uint_1 + "' LIMIT 1");
			}
			return result != null;
		}
		public int method_4(int int_0, int int_1)
		{
			int num = 0;
			foreach (Class92 current in this.dictionary_0.Values)
			{
				if ((ulong)current.uint_0 <= (ulong)((long)int_0))
				{
					
					{
						if (current.int_1 == int_1)
						{
							num++;
						}
					}
				}
			}
			return num;
		}
		public int method_5(uint uint_1, int int_0)
		{
			int num = 0;
			
			{
				foreach (Class92 current in this.dictionary_0.Values)
				{
					if (current.uint_1 == uint_1 || current.uint_1 == 0u)
					{
						if (current.int_1 == int_0)
						{
							num++;
						}
					}
				}
				return num;
			}
		}
		public Class92 method_6(int int_0)
		{
			if (!this.dictionary_0.ContainsKey(int_0))
			{
				return null;
			}
			return this.dictionary_0[int_0];
		}
		public void method_7(Class3 class3_0, int int_0, uint uint_1, string string_0, bool bool_0, string string_1, string string_2)
		{
			Class92 @class = this.method_6(int_0);
			if (@class == null || !@class.bool_1 || !@class.bool_0 || @class.uint_0 > class3_0.method_2().uint_1)
			{
				return;
			}
			if (@class.bool_2 && (!class3_0.method_2().method_24().method_2("habbo_club") || !class3_0.method_2().method_24().method_2("habbo_vip")))
			{
				return;
			}
			Class93 class2 = @class.method_1(uint_1);
			if (class2 == null)
			{
				return;
			}
			uint num = 0u;
			
			{
				if (bool_0)
				{
					if (!class2.method_0().bool_6)
					{
						return;
					}
					Class29 class3 = Class1.smethod_15().method_9().method_17(class3_0.method_2().uint_3);
					if (class3 == null)
					{
						return;
					}
					Class30 class4 = class3.method_49(class3_0.method_2().uint_0);
					if (class4 == null)
					{
						return;
					}
					TimeSpan timeSpan = DateTime.Now - class4.dateTime_0;
					if (timeSpan.Seconds > 4)
					{
						class4.int_13 = 0;
					}
					if (timeSpan.Seconds < 4 && class4.int_13 > 3)
					{
						GClass6 gClass = new GClass6(27u);
						gClass.method_9(class3_0.method_2().method_8());
						class4.method_16().method_14(gClass);
						class4.bool_9 = true;
						return;
					}
					if (class4.bool_9 && timeSpan.Seconds < class3_0.method_2().method_8())
					{
						return;
					}
					class4.bool_9 = false;
					class4.dateTime_0 = DateTime.Now;
					class4.int_13++;
					using (Class13 class5 = Class1.smethod_12().method_0())
					{
						class5.method_0("gift_user", string_1);
						try
						{
							num = (uint)class5.method_4("SELECT id FROM users WHERE username = @gift_user LIMIT 1")[0];
						}
						catch (Exception)
						{
						}
					}
					if (num == 0u)
					{
						GClass6 gClass2 = new GClass6(76u);
						gClass2.method_13(true);
						gClass2.method_7(string_1);
						class3_0.method_14(gClass2);
						return;
					}
				}
				bool flag = false;
				bool flag2 = false;
				int int_ = class2.int_2;
				if (class3_0.method_2().int_0 < class2.int_0)
				{
					flag = true;
				}
				if ((int_ == 0 && class3_0.method_2().int_1 < class2.int_1) || (int_ > 0 && class3_0.method_2().int_10 < class2.int_1))
				{
					flag2 = true;
				}
				if (flag || flag2)
				{
					GClass6 gClass3 = new GClass6(68u);
					gClass3.method_13(flag);
					gClass3.method_13(flag2);
					class3_0.method_14(gClass3);
					return;
				}
				if (bool_0 && class2.method_0().char_0 == 'e')
				{
					class3_0.method_8("You can not send this item as a gift.");
					return;
				}
				string a;
				if ((a = class2.method_0().string_2.ToLower()) != null)
				{
					if (a == "pet")
					{
						try
						{
							string[] array = string_0.Split(new char[]
							{
								'\n'
							});
							string string_3 = array[0];
							string text = array[1];
							string text2 = array[2];
							int.Parse(text);
							if (!this.method_8(string_3))
							{
								return;
							}
							if (text.Length > 2)
							{
								return;
							}
							if (text2.Length == 6)
							{
								goto IL_440;
							}
							return;
						}
						catch (Exception)
						{
							return;
						}
					}
					if (a == "roomeffect")
					{
						double num2 = 0.0;
						try
						{
							num2 = double.Parse(string_0);
						}
						catch (Exception)
						{
						}
						string_0 = num2.ToString().Replace(',', '.');
						goto IL_440;
					}
					if (a == "postit")
					{
						string_0 = "FFFF33";
						goto IL_440;
					}
					if (a == "dimmer")
					{
						string_0 = "1,1,1,#000000,255";
						goto IL_440;
					}
					if (a == "trophy")
					{
						string_0 = string.Concat(new object[]
						{
							class3_0.method_2().string_0,
							Convert.ToChar(9),
							DateTime.Now.Day,
							"-",
							DateTime.Now.Month,
							"-",
							DateTime.Now.Year,
							Convert.ToChar(9),
							Class19.smethod_4(Class1.smethod_8(string_0, true, true))
						});
						goto IL_440;
					}
				}
				string_0 = "";
				IL_440:
				if (class2.int_0 > 0)
				{
					class3_0.method_2().int_0 -= class2.int_0;
					class3_0.method_2().method_18(true);
				}
				if (class2.int_1 > 0 && int_ == 0)
				{
					class3_0.method_2().int_1 -= class2.int_1;
					class3_0.method_2().method_20(0);
				}
				if (class2.int_1 > 0 && int_ > 0)
				{
					class3_0.method_2().int_10 -= class2.int_1;
					class3_0.method_2().method_20(0);
					class3_0.method_2().method_19(false, true);
				}
				GClass6 gClass4 = new GClass6(67u);
				gClass4.method_11(class2.method_0().UInt32_0);
				gClass4.method_7(class2.method_0().string_1);
				gClass4.method_9(class2.int_0);
				gClass4.method_9(0);
				gClass4.method_9(class2.int_1);
				gClass4.method_9(class2.int_2);
				gClass4.method_9(1);
				gClass4.method_7(class2.method_0().char_0.ToString());
				gClass4.method_9(class2.method_0().int_0);
				gClass4.method_7("");
				gClass4.method_9(1);
				gClass4.method_9(-1);
				gClass4.method_7("");
				class3_0.method_14(gClass4);
				if (bool_0)
				{
					uint num3 = this.method_15();
					Class45 class6 = this.method_10();
					using (Class13 class7 = Class1.smethod_12().method_0())
					{
						class7.method_0("gift_message", "!" + Class19.smethod_4(Class1.smethod_8(string_2, true, true)) + " - " + class3_0.method_2().string_0);
						class7.method_0("extra_data", string_0);
						class7.method_1(string.Concat(new object[]
						{
							"INSERT INTO items (id,user_id,base_item,extra_data,wall_pos) VALUES ('",
							num3,
							"','",
							num,
							"','",
							class6.UInt32_0,
							"',@gift_message,'')"
						}));
						class7.method_1(string.Concat(new object[]
						{
							"INSERT INTO user_presents (item_id,base_id,amount,extra_data) VALUES ('",
							num3,
							"','",
							class2.method_0().UInt32_0,
							"','",
							class2.int_3,
							"',@extra_data)"
						}));
					}
					Class3 class8 = Class1.smethod_15().method_2().method_10(num);
					if (class8 != null)
					{
						class8.method_8("You have received a gift! Check your inventory.");
						class8.method_2().method_27().method_9(true);
						class8.method_2().int_18++;
						int int_2 = class8.method_2().int_18;
						if (int_2 > 60)
						{
							if (int_2 <= 120)
							{
								if (int_2 != 80)
								{
									if (int_2 == 120)
									{
										Class1.smethod_15().method_12().method_1(class8, 25u, 7);
									}
								}
								else
								{
									Class1.smethod_15().method_12().method_1(class8, 25u, 6);
								}
							}
							else
							{
								if (int_2 == 140)
								{
									Class1.smethod_15().method_12().method_1(class8, 25u, 8);
								}
								else
								{
									if (int_2 != 160)
									{
										if (int_2 == 200)
										{
											Class1.smethod_15().method_12().method_1(class8, 25u, 10);
										}
									}
									else
									{
										Class1.smethod_15().method_12().method_1(class8, 25u, 9);
									}
								}
							}
						}
						else
						{
							if (int_2 <= 15)
							{
								if (int_2 != 5)
								{
									if (int_2 == 15)
									{
										Class1.smethod_15().method_12().method_1(class8, 25u, 2);
									}
								}
								else
								{
									Class1.smethod_15().method_12().method_1(class8, 25u, 1);
								}
							}
							else
							{
								if (int_2 != 35)
								{
									if (int_2 != 50)
									{
										if (int_2 == 60)
										{
											Class1.smethod_15().method_12().method_1(class8, 25u, 5);
										}
									}
									else
									{
										Class1.smethod_15().method_12().method_1(class8, 25u, 4);
									}
								}
								else
								{
									Class1.smethod_15().method_12().method_1(class8, 25u, 3);
								}
							}
						}
					}
					class3_0.method_2().int_17++;
					int int_3 = class3_0.method_2().int_17;
					if (int_3 <= 60)
					{
						if (int_3 <= 15)
						{
							if (int_3 != 5)
							{
								if (int_3 == 15)
								{
									Class1.smethod_15().method_12().method_1(class3_0, 24u, 2);
								}
							}
							else
							{
								Class1.smethod_15().method_12().method_1(class3_0, 24u, 1);
							}
						}
						else
						{
							if (int_3 != 35)
							{
								if (int_3 != 50)
								{
									if (int_3 == 60)
									{
										Class1.smethod_15().method_12().method_1(class3_0, 24u, 5);
									}
								}
								else
								{
									Class1.smethod_15().method_12().method_1(class3_0, 24u, 4);
								}
							}
							else
							{
								Class1.smethod_15().method_12().method_1(class3_0, 24u, 3);
							}
						}
					}
					else
					{
						if (int_3 <= 120)
						{
							if (int_3 == 80)
							{
								Class1.smethod_15().method_12().method_1(class3_0, 24u, 6);
							}
							else
							{
								if (int_3 == 120)
								{
									Class1.smethod_15().method_12().method_1(class3_0, 24u, 7);
								}
							}
						}
						else
						{
							if (int_3 != 140)
							{
								if (int_3 != 160)
								{
									if (int_3 == 200)
									{
										Class1.smethod_15().method_12().method_1(class3_0, 24u, 10);
									}
								}
								else
								{
									Class1.smethod_15().method_12().method_1(class3_0, 24u, 9);
								}
							}
							else
							{
								Class1.smethod_15().method_12().method_1(class3_0, 24u, 8);
							}
						}
					}
					class3_0.method_8("Gift sent successfully!");
					return;
				}
				this.method_9(class3_0, class2.method_0(), class2.int_3, string_0, true, 0u);
			}
		}
		public bool method_8(string string_0)
		{
			return string_0.Length >= 1 && string_0.Length <= 16 && Class1.smethod_9(string_0) && !(string_0 != Class19.smethod_4(string_0));
		}
		public void method_9(Class3 class3_0, Class45 class45_0, int int_0, string string_0, bool bool_0, uint uint_1)
		{
			
			{
				string a;
				if ((a = class45_0.char_0.ToString()) != null)
				{
					if (a == "i" || a == "s")
					{
						int i = 0;
						while (i < int_0)
						{
							uint num;
							if (!bool_0 && uint_1 > 0u)
							{
								num = uint_1;
							}
							else
							{
								num = this.method_15();
							}
							string a2;
							if ((a2 = class45_0.string_2.ToLower()) == null)
							{
								goto IL_410;
							}
							if (!(a2 == "pet"))
							{
								if (a2 == "teleport")
								{
									uint num2 = this.method_15();
									using (Class13 @class = Class1.smethod_12().method_0())
									{
										@class.method_1(string.Concat(new object[]
										{
											"INSERT INTO tele_links (tele_one_id,tele_two_id) VALUES ('",
											num,
											"','",
											num2,
											"')"
										}));
										@class.method_1(string.Concat(new object[]
										{
											"INSERT INTO tele_links (tele_one_id,tele_two_id) VALUES ('",
											num2,
											"','",
											num,
											"')"
										}));
									}
									class3_0.method_2().method_27().method_11(num2, class45_0.UInt32_0, "0", bool_0);
									class3_0.method_2().method_27().method_11(num, class45_0.UInt32_0, "0", bool_0);
								}
								else
								{
									if (!(a2 == "dimmer"))
									{
										goto IL_410;
									}
									using (Class13 class2 = Class1.smethod_12().method_0())
									{
										class2.method_1("INSERT INTO room_items_moodlight (item_id,enabled,current_preset,preset_one,preset_two,preset_three) VALUES ('" + num + "','0','1','#000000,255,0','#000000,255,0','#000000,255,0')");
									}
									class3_0.method_2().method_27().method_11(num, class45_0.UInt32_0, string_0, bool_0);
								}
							}
							else
							{
								string[] array = string_0.Split(new char[]
								{
									'\n'
								});
								Class82 class82_ = this.method_11(class3_0.method_2().uint_0, array[0], Convert.ToInt32(class45_0.string_1.Split(new char[]
								{
									't'
								})[1]), array[1], array[2]);
								class3_0.method_2().method_27().method_7(class82_);
								class3_0.method_2().method_27().method_11(num, 320u, "0", bool_0);
							}
							IL_4BB:
							GClass6 gClass = new GClass6(832u);
							gClass.method_9(1);
							if (!(class45_0.string_2.ToLower() == "pet"))
							{
								if (!(class45_0.char_0.ToString() == "i"))
								{
									gClass.method_9(1);
								}
								else
								{
									gClass.method_9(2);
								}
							}
							else
							{
								gClass.method_9(3);
							}
							gClass.method_9(1);
							gClass.method_11(num);
							class3_0.method_14(gClass);
							i++;
							continue;
							IL_410:
							class3_0.method_2().method_27().method_11(num, class45_0.UInt32_0, string_0, bool_0);
							goto IL_4BB;
						}
						class3_0.method_2().method_27().method_9(false);
						return;
					}
					if (a == "e")
					{
						for (int j = 0; j < int_0; j++)
						{
							class3_0.method_2().method_28().method_0(class45_0.int_0, 3600);
						}
						return;
					}
					if (a == "h")
					{
						for (int k = 0; k < int_0; k++)
						{
							class3_0.method_2().method_24().method_3("habbo_club", 2678400);
						}
						if (!class3_0.method_2().method_26().method_1("HC1"))
						{
							class3_0.method_2().method_26().method_2("HC1", true);
						}
						GClass6 gClass2 = new GClass6(7u);
						gClass2.method_7("habbo_club");
						if (!class3_0.method_2().method_24().method_2("habbo_club"))
						{
							for (int l = 0; l < 3; l++)
							{
								gClass2.method_9(0);
							}
						}
						else
						{
							double num3 = (double)class3_0.method_2().method_24().method_1("habbo_club").Int32_0;
							double num4 = (num3 - Class1.smethod_6());
							int num5 = (int)Math.Ceiling(num4 / 86400.0);
							int num6 = num5 / 31;
							if (num6 >= 1)
							{
								num6--;
							}
							gClass2.method_9(num5 - num6 * 31);
							gClass2.method_13(true);
							gClass2.method_9(num6);
						}
						class3_0.method_14(gClass2);
						GClass6 gClass3 = new GClass6(2u);
						if (!class3_0.method_2().bool_13 && !Class15.Boolean_2)
						{
							if (class3_0.method_2().method_24().method_2("habbo_club"))
							{
								gClass3.method_9(1);
							}
							else
							{
								gClass3.method_9(0);
							}
						}
						else
						{
							gClass3.method_9(2);
						}
						if (!class3_0.method_2().method_7("acc_anyroomowner"))
						{
							if (class3_0.method_2().method_7("acc_anyroomrights"))
							{
								gClass3.method_9(5);
							}
							else
							{
								if (!class3_0.method_2().method_7("acc_supporttool"))
								{
									if (!class3_0.method_2().bool_13 && !Class15.Boolean_2 && !class3_0.method_2().method_24().method_2("habbo_club"))
									{
										gClass3.method_9(0);
									}
									else
									{
										gClass3.method_9(2);
									}
								}
								else
								{
									gClass3.method_9(4);
								}
							}
						}
						else
						{
							gClass3.method_9(7);
						}
						class3_0.method_14(gClass3);
						return;
					}
				}
				class3_0.method_8("Something went wrong! The item type could not be processed. Please do not try to buy this item anymore, instead inform support as soon as possible.");
			}
		}
		public Class45 method_10()
		{
			switch (Class1.smethod_5(0, 6))
			{
			case 0:
				IL_2C:
				return Class1.smethod_15().method_8().method_2(164u);
			case 1:
				return Class1.smethod_15().method_8().method_2(165u);
			case 2:
				return Class1.smethod_15().method_8().method_2(166u);
			case 3:
				return Class1.smethod_15().method_8().method_2(167u);
			case 4:
				return Class1.smethod_15().method_8().method_2(168u);
			case 5:
				return Class1.smethod_15().method_8().method_2(169u);
			case 6:
				return Class1.smethod_15().method_8().method_2(170u);
			}
			//goto IL_2C;
            return null;
		}
		public Class82 method_11(uint uint_1, string string_0, int int_0, string string_1, string string_2)
		{
			return new Class82(this.method_15(), uint_1, 0u, string_0, ((uint)int_0), string_1, string_2, 0, 100, 100, 0, Class1.smethod_6(), 0, 0, 0.0)
			{
				enum2_0 = Enum2.const_2
			};
		}
		public Class82 method_12(DataRow dataRow_0)
		{
			if (dataRow_0 == null)
			{
				return null;
			}
			return new Class82((uint)dataRow_0["id"], (uint)dataRow_0["user_id"], (uint)dataRow_0["room_id"], (string)dataRow_0["name"], (uint)dataRow_0["type"], (string)dataRow_0["race"], (string)dataRow_0["color"], (int)dataRow_0["expirience"], (int)dataRow_0["energy"], (int)dataRow_0["nutrition"], (int)dataRow_0["respect"], (double)dataRow_0["createstamp"], (int)dataRow_0["x"], (int)dataRow_0["y"], (double)dataRow_0["z"]);
		}
		internal Class82 method_13(DataRow dataRow_0, uint uint_1)
		{
			if (dataRow_0 == null)
			{
				return null;
			}
			return new Class82(uint_1, (uint)dataRow_0["user_id"], (uint)dataRow_0["room_id"], (string)dataRow_0["name"], (uint)dataRow_0["type"], (string)dataRow_0["race"], (string)dataRow_0["color"], (int)dataRow_0["expirience"], (int)dataRow_0["energy"], (int)dataRow_0["nutrition"], (int)dataRow_0["respect"], (double)dataRow_0["createstamp"], (int)dataRow_0["x"], (int)dataRow_0["y"], (double)dataRow_0["z"]);
		}
		internal Class82 method_14(Class30 class30_0, uint uint_1)
		{
			return new Class82(20699u, ((uint)class30_0.int_0), uint_1, "Apophis", 12u, "3", "FFFFFF", 0, 0, 0, 0, 1330504773.72729, class30_0.int_3, class30_0.int_4, class30_0.double_0);
		}
		internal uint method_15()
		{
			uint result;
			lock (this.object_0)
			{
				result = this.uint_0++;
			}
			return result;
		}
		public Class94 method_16()
		{
			uint uint_ = 1u;
			if (Class1.smethod_5(1, 2000) == 2000)
			{
				uint_ = 5u;
			}
			else
			{
				if (Class1.smethod_5(1, 200) != 200)
				{
					if (Class1.smethod_5(1, 40) != 40)
					{
						if (Class1.smethod_5(1, 4) == 4)
						{
							uint_ = 2u;
						}
					}
					else
					{
						uint_ = 3u;
					}
				}
				else
				{
					uint_ = 4u;
				}
			}
			List<Class94> list = this.method_17(uint_);
			if (list == null || list.Count < 1)
			{
				return new Class94(0u, 0u, 1479u, 0u);
			}
			return list[Class1.smethod_5(0, (list.Count - 1))];
		}
		public List<Class94> method_17(uint uint_1)
		{
			List<Class94> list = new List<Class94>();
			foreach (Class94 current in this.list_0)
			{
				if (current.uint_3 == uint_1)
				{
					list.Add(current);
				}
			}
			return list;
		}
		public GClass6 method_18(uint uint_1)
		{
			GClass6 gClass = new GClass6(126u);
			gClass.method_13(true);
			gClass.method_9(0);
			gClass.method_9(0);
			gClass.method_9(-1);
			gClass.method_7("");
			gClass.method_9(this.method_5(uint_1, -1));
			gClass.method_13(true);
			foreach (Class92 current in this.dictionary_0.Values)
			{
				if (current.int_1 == -1 && (current.uint_1 == uint_1 || current.uint_1 == 0u))
				{
					current.method_2(7, gClass);
					foreach (Class92 current2 in this.dictionary_0.Values)
					{
						if (current2.int_1 == current.Int32_0)
						{
							current2.method_2(7, gClass);
						}
					}
				}
			}
			return gClass;
		}
		public GClass6 method_19(int int_0)
		{
			GClass6 gClass = new GClass6(126u);
			gClass.method_13(true);
			gClass.method_9(0);
			gClass.method_9(0);
			gClass.method_9(-1);
			gClass.method_7("");
			gClass.method_9(this.method_4(int_0, -1));
			gClass.method_13(true);
			foreach (Class92 current in this.dictionary_0.Values)
			{
				if (current.int_1 == -1)
				{
					current.method_2(int_0, gClass);
					foreach (Class92 current2 in this.dictionary_0.Values)
					{
						if (current2.int_1 == current.Int32_0)
						{
							current2.method_2(int_0, gClass);
						}
					}
				}
			}
			return gClass;
		}
		internal GClass6 method_20(uint uint_1)
		{
			if (uint_1 < 1u)
			{
				uint_1 = 1u;
			}
			if (uint_1 > 7u)
			{
				uint_1 = 7u;
			}
			return this.gclass6_0[(int)((UIntPtr)uint_1)];
		}
		internal GClass6 method_21(uint uint_1)
		{
			return this.method_18(uint_1);
		}
		public GClass6 method_22(Class92 class92_0)
		{
			GClass6 gClass = new GClass6(127u);
			gClass.method_9(class92_0.Int32_0);
			string string_;
			switch (string_ = class92_0.string_1)
			{
			case "frontpage":
				gClass.method_7("frontpage3");
				gClass.method_9(3);
				gClass.method_7(class92_0.string_2);
				gClass.method_7(class92_0.string_3);
				gClass.method_7("");
				gClass.method_9(11);
				gClass.method_7(class92_0.string_5);
				gClass.method_7(class92_0.string_9);
				gClass.method_7(class92_0.string_6);
				gClass.method_7(class92_0.string_7);
				gClass.method_7(class92_0.string_10);
				gClass.method_7("#FAF8CC");
				gClass.method_7("#FAF8CC");
				gClass.method_7("Read More >");
				gClass.method_7("magic.credits");
				goto IL_412;
			case "recycler_info":
				gClass.method_7(class92_0.string_1);
				gClass.method_9(2);
				gClass.method_7(class92_0.string_2);
				gClass.method_7(class92_0.string_3);
				gClass.method_9(3);
				gClass.method_7(class92_0.string_5);
				gClass.method_7(class92_0.string_6);
				gClass.method_7(class92_0.string_7);
				goto IL_412;
			case "recycler_prizes":
				gClass.method_7("recycler_prizes");
				gClass.method_9(1);
				gClass.method_7("catalog_recycler_headline3");
				gClass.method_9(1);
				gClass.method_7(class92_0.string_5);
				goto IL_412;
			case "spaces":
				gClass.method_7("spaces_new");
				gClass.method_9(1);
				gClass.method_7(class92_0.string_2);
				gClass.method_9(1);
				gClass.method_7(class92_0.string_5);
				goto IL_412;
			case "recycler":
				gClass.method_7(class92_0.string_1);
				gClass.method_9(2);
				gClass.method_7(class92_0.string_2);
				gClass.method_7(class92_0.string_3);
				gClass.method_9(1);
				gClass.method_8(class92_0.string_5, 10);
				gClass.method_7(class92_0.string_6);
				gClass.method_7(class92_0.string_7);
				goto IL_412;
			case "trophies":
				gClass.method_7("trophies");
				gClass.method_9(1);
				gClass.method_7(class92_0.string_2);
				gClass.method_9(2);
				gClass.method_7(class92_0.string_5);
				gClass.method_7(class92_0.string_7);
				goto IL_412;
			case "pets":
				gClass.method_7("pets");
				gClass.method_9(2);
				gClass.method_7(class92_0.string_2);
				gClass.method_7(class92_0.string_3);
				gClass.method_9(4);
				gClass.method_7(class92_0.string_5);
				gClass.method_7("");
				gClass.method_7("Pick a color:");
				gClass.method_7("Pick a race:");
				goto IL_412;
			case "club_buy":
				gClass.method_7("club_buy");
				gClass.method_9(1);
				gClass.method_7("habboclub_2");
				gClass.method_9(1);
				goto IL_412;
			case "club_gifts":
				gClass.method_7("club_gifts");
				gClass.method_9(1);
				gClass.method_7("habboclub_2");
				gClass.method_9(1);
				gClass.method_7("");
				gClass.method_9(1);
				goto IL_412;
			}
			gClass.method_7(class92_0.string_1);
			gClass.method_9(3);
			gClass.method_7(class92_0.string_2);
			gClass.method_7(class92_0.string_3);
			gClass.method_7(class92_0.string_4);
			gClass.method_9(3);
			gClass.method_7(class92_0.string_5);
			gClass.method_7(class92_0.string_7);
			gClass.method_7(class92_0.string_8);
			IL_412:
			gClass.method_9(class92_0.list_0.Count);
			foreach (Class93 current in class92_0.list_0)
			{
				current.method_1(gClass);
			}
			return gClass;
		}
		public GClass6 method_23()
		{
			return new GClass6(625u);
		}
		public GClass6 method_24()
		{
			GClass6 gClass = new GClass6(126u);
			gClass.method_9(0);
			gClass.method_9(0);
			gClass.method_9(0);
			gClass.method_9(-1);
			gClass.method_7("");
			gClass.method_9(0);
			gClass.method_9(100);
			
			{
				for (int i = 1; i <= 150; i++)
				{
					gClass.method_9(1);
					gClass.method_9(i);
					gClass.method_9(i);
					gClass.method_9(i);
					gClass.method_7("#" + i);
					gClass.method_9(0);
					gClass.method_9(0);
				}
				return gClass;
			}
		}
		public Class95 method_25()
		{
			return this.class95_0;
		}
		public Class96 method_26()
		{
			return this.class96_0;
		}
	}
}
