using Phoenix.Core;
using Phoenix.HabboHotel.GameClients;
using Phoenix.HabboHotel.Rooms;
using Phoenix.HabboHotel.Users.Messenger;
using Phoenix.Messages;
using Phoenix.Storage;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Runtime.CompilerServices;
namespace Phoenix.HabboHotel.Navigators
{
	internal class Class106
	{
		private Dictionary<int, string> dictionary_0;
		private List<Class107> list_0;
		private Dictionary<int, Class108> dictionary_1;
		[CompilerGenerated]
		private static Comparison<KeyValuePair<string, int>> comparison_0;
		[CompilerGenerated]
		private static Func<Class109, int> func_0;
		[CompilerGenerated]
		private static Func<Class29, int> func_1;
		[CompilerGenerated]
		private static Func<Class29, int> func_2;
		public Class106()
		{
			this.dictionary_0 = new Dictionary<int, string>();
			this.list_0 = new List<Class107>();
			this.dictionary_1 = new Dictionary<int, Class108>();
		}
		public void method_0(Class13 class13_0)
		{
			GClass2.smethod_0("Loading Navigator..");
			this.dictionary_0.Clear();
			this.list_0.Clear();
			this.dictionary_1.Clear();
			DataTable dataTable = class13_0.method_3("SELECT id,caption FROM navigator_pubcats WHERE enabled = '1'");
			DataTable dataTable2 = class13_0.method_3("SELECT id,caption,min_rank FROM navigator_flatcats WHERE enabled = '1'");
			DataTable dataTable3 = class13_0.method_3("SELECT id,bannertype,caption,image,image_type,room_id,category_id,category_parent_id FROM navigator_publics ORDER BY ordernum ASC;");
			if (dataTable != null)
			{
				foreach (DataRow dataRow in dataTable.Rows)
				{
					this.dictionary_0.Add((int)dataRow["id"], (string)dataRow["caption"]);
				}
			}
			if (dataTable2 != null)
			{
				foreach (DataRow dataRow2 in dataTable2.Rows)
				{
					this.list_0.Add(new Class107((int)dataRow2["id"], (string)dataRow2["caption"], (int)dataRow2["min_rank"]));
				}
			}
			if (dataTable3 != null)
			{
				foreach (DataRow dataRow3 in dataTable3.Rows)
				{
					this.dictionary_1.Add((int)dataRow3["id"], new Class108((int)dataRow3["id"], int.Parse(dataRow3["bannertype"].ToString()), (string)dataRow3["caption"], (string)dataRow3["image"], (dataRow3["image_type"].ToString().ToLower() == "internal") ? Enum3.const_0 : Enum3.const_1, (uint)dataRow3["room_id"], (int)dataRow3["category_id"], (int)dataRow3["category_parent_id"]));
				}
			}
		}
		public int method_1(int int_0)
		{
			int num = 0;
			
			{
				foreach (Class108 current in this.dictionary_1.Values)
				{
					if (current.int_3 == int_0 || int_0 == -1)
					{
						num++;
					}
				}
				return num;
			}
		}
		public Class107 method_2(int int_0)
		{
			using (GStruct0.smethod_0(this.list_0))
			{
				foreach (Class107 current in this.list_0)
				{
					if (current.int_0 == int_0)
					{
						return current;
					}
				}
			}
			return null;
		}
		public GClass6 method_3()
		{
			GClass6 gClass = new GClass6(221u);
			gClass.method_9(this.list_0.Count);
			foreach (Class107 current in this.list_0)
			{
				if (current.int_0 > 0)
				{
					gClass.method_13(true);
				}
				if (current.int_0 != 15)
				{
					gClass.method_9(current.int_0);
				}
				gClass.method_7(current.string_0);
			}
			gClass.method_7("");
			return gClass;
		}
		public GClass6 method_4()
		{
			GClass6 gClass = new GClass6(450u);
			gClass.method_9(this.method_1(-1));
			foreach (Class108 current in this.dictionary_1.Values)
			{
				current.method_0(gClass);
			}
			return gClass;
		}
		public GClass6 method_5(Class3 class3_0)
		{
			GClass6 gClass = new GClass6(451u);
			gClass.method_9(0);
			gClass.method_9(6);
			gClass.method_7("");
			gClass.method_9(class3_0.method_2().list_0.Count);
			using (GStruct0.smethod_0(class3_0.method_2().list_0))
			{
				foreach (uint current in class3_0.method_2().list_0)
				{
					Class1.smethod_15().method_9().method_10(current).method_3(gClass, false);
				}
			}
			return gClass;
		}
		public GClass6 method_6(Class3 class3_0)
		{
			GClass6 result;
			using (Class13 @class = Class1.smethod_12().method_0())
			{
				DataTable dataTable = @class.method_3("SELECT * FROM rooms JOIN user_roomvisits ON rooms.id = user_roomvisits.room_id WHERE user_roomvisits.user_id = '" + class3_0.method_2().uint_0 + "' ORDER BY entry_timestamp DESC LIMIT 50;");
				List<Class109> list = new List<Class109>();
				List<uint> list2 = new List<uint>();
				if (dataTable != null)
				{
					foreach (DataRow dataRow in dataTable.Rows)
					{
						Class109 class2 = Class1.smethod_15().method_9().method_15((uint)dataRow["id"], dataRow);
						class2.method_1(dataRow);
						list.Add(class2);
						list2.Add(class2.uint_0);
					}
				}
				GClass6 gClass = new GClass6(451u);
				gClass.method_9(0);
				gClass.method_9(7);
				gClass.method_7("");
				gClass.method_9(list.Count);
				foreach (Class109 current in list)
				{
					current.method_3(gClass, false);
				}
				result = gClass;
			}
			return result;
		}
		public GClass6 method_7(Class3 class3_0, int int_0)
		{
			GClass6 gClass = new GClass6(451u);
			gClass.method_9(int_0);
			gClass.method_9(12);
			gClass.method_7("");
			List<Class29> list = Class1.smethod_15().method_9().method_5(int_0);
			gClass.method_9(list.Count);
			foreach (Class29 current in list)
			{
				Class109 class109_ = current.Class109_0;
				class109_.method_3(gClass, true);
			}
			return gClass;
		}
		public GClass6 method_8()
		{
			Dictionary<string, int> dictionary = new Dictionary<string, int>();
			GClass6 result;
			using (Class13 @class = Class1.smethod_12().method_0())
			{
				DataTable dataTable = @class.method_3("SELECT tags,users_now FROM rooms WHERE roomtype = 'private' AND users_now > 0 ORDER BY users_now DESC LIMIT 50;");
				if (dataTable != null)
				{
					foreach (DataRow dataRow in dataTable.Rows)
					{
						List<string> list = new List<string>();
						string[] array = dataRow["tags"].ToString().Split(new char[]
						{
							','
						});
						for (int i = 0; i < array.Length; i++)
						{
							string item = array[i];
							list.Add(item);
						}
						foreach (string current in list)
						{
							if (!dictionary.ContainsKey(current))
							{
								dictionary.Add(current, (int)dataRow["users_now"]);
							}
							else
							{
								Dictionary<string, int> dictionary2;
								string key;
								(dictionary2 = dictionary)[key = current] = (dictionary2[key] + (int)dataRow["users_now"]);
							}
						}
					}
				}
				List<KeyValuePair<string, int>> list2 = new List<KeyValuePair<string, int>>(dictionary);
				List<KeyValuePair<string, int>> arg_15C_0 = list2;
				if (Class106.comparison_0 == null)
				{
					Class106.comparison_0 = new Comparison<KeyValuePair<string, int>>(Class106.smethod_0);
				}
				arg_15C_0.Sort(Class106.comparison_0);
				GClass6 gClass = new GClass6(452u);
				gClass.method_9(list2.Count);
				foreach (KeyValuePair<string, int> current2 in list2)
				{
					gClass.method_7(current2.Key);
					gClass.method_9(current2.Value);
				}
				result = gClass;
			}
			return result;
		}
		public GClass6 method_9(string string_0)
		{
			DataTable dataTable = null;
			using (Class13 @class = Class1.smethod_12().method_0())
			{
				string_0 = Class1.smethod_7(string_0.ToLower()).Trim();
				if (string_0.Length > 0)
				{
					if (!string_0.StartsWith("owner:"))
					{
						@class.method_0("query", string_0 + "%");
						@class.method_0("tags_query", "%" + string_0 + "%");
						dataTable = @class.method_3("SELECT * FROM rooms WHERE caption LIKE @query AND roomtype = 'private' OR owner LIKE @query AND roomtype = 'private' ORDER BY users_now DESC LIMIT 40");
					}
					else
					{
						string_0 = string_0.Replace(" ", "");
						@class.method_0("query", string_0.Substring(6));
						dataTable = @class.method_3("SELECT * FROM rooms WHERE owner = @query AND roomtype = 'private' ORDER BY users_now DESC LIMIT 40");
					}
				}
			}
			List<Class109> list = new List<Class109>();
			if (dataTable != null)
			{
				foreach (DataRow dataRow in dataTable.Rows)
				{
					Class109 item = Class1.smethod_15().method_9().method_15((uint)dataRow["id"], dataRow);
					list.Add(item);
				}
			}
			GClass6 gClass = new GClass6(451u);
			gClass.method_9(1);
			gClass.method_9(9);
			gClass.method_7(string_0);
			gClass.method_9(list.Count);
			foreach (Class109 current in list)
			{
				current.method_3(gClass, false);
			}
			return gClass;
		}
		internal byte[] method_10(Class3 class3_0, int int_0)
		{
			if (int_0 != -2)
			{
				return this.method_11(class3_0, int_0).method_14();
			}
			byte[] array = Class1.smethod_15().method_15().method_1(int_0);
			if (array == null)
			{
				return this.method_11(null, int_0).method_14();
			}
			return array;
		}
		public GClass6 method_11(Class3 class3_0, int int_0)
		{
			GClass6 gClass = new GClass6(451u);
			if (int_0 < -1)
			{
				if (int_0 == -2)
				{
					gClass.method_9(0);
					gClass.method_9(2);
				}
				else
				{
					if (int_0 != -3)
					{
						if (int_0 == -4)
						{
							gClass.method_9(0);
							gClass.method_9(3);
						}
						else
						{
							if (int_0 == -5)
							{
								gClass.method_9(0);
								gClass.method_9(4);
							}
						}
					}
					else
					{
						gClass.method_9(0);
						gClass.method_9(5);
					}
				}
			}
			else
			{
				gClass.method_9(int_0);
				gClass.method_9(1);
			}
			gClass.method_7("");
			List<Class109> list = new List<Class109>();
			
			{
				switch (int_0)
				{
				case -5:
				case -4:
					break;
				case -3:
					goto IL_361;
				case -2:
					goto IL_3A4;
				case -1:
					goto IL_437;
				default:
				{
					Dictionary<Class29, int> dictionary = Class1.smethod_15().method_9().method_19();
					IEnumerable<Class109> enumerable = 
						from k in Class1.smethod_15().method_9().list_3
						where k.int_1 == int_0
						select k;
					IEnumerable<Class29> arg_14A_0 = 
						from k in dictionary.Keys
						where k.int_0 == int_0
						select k;
					if (Class106.func_2 == null)
					{
						Class106.func_2 = new Func<Class29, int>(Class106.smethod_3);
					}
					IOrderedEnumerable<Class29> orderedEnumerable = arg_14A_0.OrderByDescending(Class106.func_2);
					new List<Class109>();
					int num = 0;
					foreach (Class29 current in orderedEnumerable)
					{
						if (num > 40)
						{
							break;
						}
						list.Add(current.Class109_0);
						num++;
					}
					using (IEnumerator<Class109> enumerator2 = enumerable.GetEnumerator())
					{
						while (enumerator2.MoveNext())
						{
							Class109 current2 = enumerator2.Current;
							if (num > 40)
							{
								break;
							}
							if (list.Contains(current2))
							{
								list.Remove(current2);
							}
							list.Add(current2);
							num++;
						}
						goto IL_4BC;
					}
					break;
				}
				}
				List<string> list2 = new List<string>();
				Dictionary<int, Class29> dictionary2 = new Dictionary<int, Class29>();
				Hashtable hashtable = class3_0.method_2().method_25().method_26().Clone() as Hashtable;
				Dictionary<Class109, int> dictionary3 = new Dictionary<Class109, int>();
				foreach (Class17 @class in hashtable.Values)
				{
					if (@class.Boolean_0 && @class.Boolean_1)
					{
						Class3 class2 = Class1.smethod_15().method_2().method_10(@class.UInt32_0);
						if (class2 != null && class2.method_2() != null && class2.method_2().Class29_0 != null)
						{
							Class109 class109_ = class2.method_2().Class29_0.Class109_0;
							if (!dictionary3.ContainsKey(class109_))
							{
								dictionary3.Add(class109_, class109_.int_2);
							}
						}
					}
				}
				IEnumerable<Class109> arg_306_0 = dictionary3.Keys;
				if (Class106.func_0 == null)
				{
					Class106.func_0 = new Func<Class109, int>(Class106.smethod_1);
				}
				IOrderedEnumerable<Class109> orderedEnumerable2 = arg_306_0.OrderByDescending(Class106.func_0);
				list2.Clear();
				dictionary2.Clear();
				hashtable.Clear();
				dictionary3.Clear();
				using (IEnumerator<Class109> enumerator4 = orderedEnumerable2.GetEnumerator())
				{
					while (enumerator4.MoveNext())
					{
						Class109 current3 = enumerator4.Current;
						list.Add(current3);
					}
					goto IL_4BC;
				}
				IL_361:
				using (List<Class109>.Enumerator enumerator5 = class3_0.method_2().list_5.GetEnumerator())
				{
					while (enumerator5.MoveNext())
					{
						Class109 current4 = enumerator5.Current;
						list.Add(current4);
					}
					goto IL_4BC;
				}
				IL_3A4:
				DataTable dataTable;
				using (Class13 class3 = Class1.smethod_12().method_0())
				{
					dataTable = class3.method_3("SELECT * FROM rooms WHERE score > 0 AND roomtype = 'private' ORDER BY score DESC LIMIT 40");
				}
				IEnumerator enumerator6 = dataTable.Rows.GetEnumerator();
				try
				{
					while (enumerator6.MoveNext())
					{
						DataRow dataRow = (DataRow)enumerator6.Current;
						list.Add(Class1.smethod_15().method_9().method_15((uint)dataRow["id"], dataRow));
					}
					goto IL_4BC;
				}
				finally
				{
					IDisposable disposable2 = enumerator6 as IDisposable;
					if (disposable2 != null)
					{
						disposable2.Dispose();
					}
				}
				IL_437:
				Dictionary<Class29, int> dictionary4 = Class1.smethod_15().method_9().method_19();
				IEnumerable<Class29> arg_46C_0 = dictionary4.Keys;
				if (Class106.func_1 == null)
				{
					Class106.func_1 = new Func<Class29, int>(Class106.smethod_2);
				}
				IOrderedEnumerable<Class29> orderedEnumerable3 = arg_46C_0.OrderByDescending(Class106.func_1);
				int num2 = 0;
				foreach (Class29 current5 in orderedEnumerable3)
				{
					if (num2 >= 40)
					{
						break;
					}
					num2++;
					list.Add(current5.Class109_0);
				}
				IL_4BC:
				gClass.method_9(list.Count);
				foreach (Class109 current6 in list)
				{
					current6.method_3(gClass, false);
				}
				return gClass;
			}
		}
		[CompilerGenerated]
		private static int smethod_0(KeyValuePair<string, int> keyValuePair_0, KeyValuePair<string, int> keyValuePair_1)
		{
			return keyValuePair_0.Value.CompareTo(keyValuePair_1.Value);
		}
		[CompilerGenerated]
		private static int smethod_1(Class109 class109_0)
		{
			return class109_0.int_2;
		}
		[CompilerGenerated]
		private static int smethod_2(Class29 class29_0)
		{
			return class29_0.Int32_0;
		}
		[CompilerGenerated]
		private static int smethod_3(Class29 class29_0)
		{
			return class29_0.Int32_0;
		}
	}
}
